/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : HeadSet extension
Version : 0.5
Date    : 07.09.2011
Author  : 
Company : 
Comments: 


Chip type           : ATtiny13
Clock frequency     : 0,128000 MHz
Memory model        : Tiny
External RAM size   : 0
Data Stack size     : 16
*****************************************************/

#include <tiny13.h>
#include <delay.h>

#define byte unsigned char

// Coefficients affect on generated frequency
byte first_divisor = 50;
byte divisor_coef = 30;

byte first_button = 3;
byte last_button = 4;

// Pin change interrupt service routine
interrupt [PCINT0] void pin_change_isr(void)
{
        char i;
     
        // Loop tries to find first pushed button.
        // If there is no such one, generator will be stopped.
        for(i = first_button; i <= last_button; i++){
                if (PCMSK & (1 << i) && ((PINB & (1 << i)))){
                        PORTB=0x02;
                        DDRB=0x02;
                        OCR0A = first_divisor + divisor_coef * (i - first_button);
                        TCCR0B=0x01;
                        return;        
                }
        }

        DDRB=0x00;
        TCCR0B=0x00;
        PORTB=0x00;
}


void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=In 
// State5=T State4=P State3=P State2=T State1=1 State0=T 
//PORTB=0x02;
//DDRB=0x02;

PORTB=0x00;
DDRB=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 128,000 kHz
// Mode: CTC top=OCR0A
// OC0A output: Disconnected
// OC0B output: Toggle on compare match
TCCR0B=0x00;
TCCR0A=0x12;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;


// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: On
GIMSK=0x20;
MCUCR=0x00;
PCMSK=0x00;
//PCMSK=0x18;
GIFR=0x20;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;

// Waiting for capacitor charging.
delay_ms(1000);
// Global enable interrupts
#asm("sei")

// Interrupt mask initialization
PCMSK=0x18;

while (1)
      {
      // Place your code here
      delay_ms(1000);
      };
}
